// 完毕：
using System;
using System.IO;
using System.Drawing;
using System.Text;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Text;
using GrapeCity.Documents.Drawing;

namespace DsPdfWeb.Demos
{
    // 这个示例加载一个PDF（我们使用Wetlands示例生成的文档）
    // 并从中提取所有图像。然后它将这些图像打印到新的 PDF 中，
    // 每页居中一个。
    public class GetImages
    {
        public int CreatePDF(Stream stream)
        {
            var tf = new TextFormat() { Font = StandardFonts.Times, FontSize = 12 };
            using (var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "Wetlands.pdf")))
            {
                var docSrc = new GcPdfDocument();
                // 加载包含一些图像的现有 PDF：
                docSrc.Load(fs);
                // 此调用从加载的 PDF 中提取有关图像的信息，
                // 请注意，对于大文件，可能需要一段时间才能完成：
                var imageInfos = docSrc.GetImages();

                var doc = new GcPdfDocument();
                var textPt = new PointF(72, 72);
                var imageRc = new RectangleF(72, 72 * 2, doc.PageSize.Width - 72 * 2, doc.PageSize.Height - 72 * 3);

                foreach (var imageInfo in imageInfos)
                {
                    // 同一张图片可能出现在多个位置，
                    // imageInfo 包括页面索引和页面位置；
                    // 为了简单起见，我们只在这里打印页码：
                    var sb = new StringBuilder();
                    imageInfo.Locations.ForEach(il_ => sb.Append((il_.Page.Index + 1).ToString() + ", "));
                    var g = doc.NewPage().Graphics;
                    g.DrawString($"This image appears on page(s) {sb.ToString().TrimEnd(' ', ',')} of the original PDF:", tf, new PointF(72, 72));
                    g.DrawImage(imageInfo.Image, imageRc, null, ImageAlign.ScaleImage);
                }
                // 完毕：
                doc.Save(stream);
                return doc.Pages.Count;
            }
        }
    }
}
